/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis_ambassador/getambassador.io/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// MappingLister helps list Mappings.
type MappingLister interface {
	// List lists all Mappings in the indexer.
	List(selector labels.Selector) (ret []*v1.Mapping, err error)
	// Mappings returns an object that can list and get Mappings.
	Mappings(namespace string) MappingNamespaceLister
	MappingListerExpansion
}

// mappingLister implements the MappingLister interface.
type mappingLister struct {
	indexer cache.Indexer
}

// NewMappingLister returns a new MappingLister.
func NewMappingLister(indexer cache.Indexer) MappingLister {
	return &mappingLister{indexer: indexer}
}

// List lists all Mappings in the indexer.
func (s *mappingLister) List(selector labels.Selector) (ret []*v1.Mapping, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.Mapping))
	})
	return ret, err
}

// Mappings returns an object that can list and get Mappings.
func (s *mappingLister) Mappings(namespace string) MappingNamespaceLister {
	return mappingNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// MappingNamespaceLister helps list and get Mappings.
type MappingNamespaceLister interface {
	// List lists all Mappings in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.Mapping, err error)
	// Get retrieves the Mapping from the indexer for a given namespace and name.
	Get(name string) (*v1.Mapping, error)
	MappingNamespaceListerExpansion
}

// mappingNamespaceLister implements the MappingNamespaceLister
// interface.
type mappingNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all Mappings in the indexer for a given namespace.
func (s mappingNamespaceLister) List(selector labels.Selector) (ret []*v1.Mapping, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.Mapping))
	})
	return ret, err
}

// Get retrieves the Mapping from the indexer for a given namespace and name.
func (s mappingNamespaceLister) Get(name string) (*v1.Mapping, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("mapping"), name)
	}
	return obj.(*v1.Mapping), nil
}
